/***************************************************************************
                                  BasicCoach.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _COACH_H_
#define _COACH_H_

#include <list>
#include <strstream.h>
#include "ServerSetting.h"
#include "WorldModel.h"
#include "Netif.h"
#include "Types.h"
#include "Parse.h"

class BasicCoach{
public:
        BasicCoach();
        BasicCoach(UDPSocket *s , Parse *parse, string &ourTeamName);
        
        
        // Set connection for coach to server
        bool SetConnection(UDPSocket *s);
        
        // Set parse pointer to coach
        bool SetParsePtr(Parse *parse);
        
        // say msg to the server
        int Send(const string &msg) const;
        int Say(const string &msg) const;
    
        // function that execute every cycle
        int UpdateRoutine();
    
        //  send msgs received to coach, msgs will be added to msg queue
        int AddNewMsg(string &msg);

        //  Update World Model
        int UpdateWorldModel(WMSnapShot &tmpWMS);
        
        
        WorldModel* GetWorldModel();
        

public:
        ServerSetting       ss;
        PlayerSetting       ps;
        PlayerTypeSetting   pts;

protected:
        WorldModel          wm;
        
        Parse               *m_parse;
        
        WMSnapShot          m_tmpWMS;  // temp data for Update
        list<string>        msgQ;      // msg queue to coach
        
        bool                bisEyeOn;       // ۾Ƿ
        bool                bisEarOn;       // Ƿ
        
private:        
        UDPSocket           *sock;
        bool                bMsgCome;       // жǷϢ
        bool                bSeeMsgCome;    // жµseeϢ
};

#endif

