/***************************************************************************
                                  Client.C 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#include "Client.h"


pthread_mutex_t     initLock = PTHREAD_MUTEX_INITIALIZER;

void *InitConnection(void *arg)
{
    UDPSocket   *s;
    string msgBuf;
    int n;
    
    // socket
    s = ((InitConnectionT*) arg)->s;

    if(((InitConnectionT*) arg)->online)
		s->SendMsg("(init " + (*((InitConnectionT*) arg)->teamName) + "(version 8.00))");
	else
		s->SendMsg("(init (version 8))");
    
    for(;;){
        n = s->RecvMsg(msgBuf);
        if (n == -1){
            // there Is sth wrong when recv msg
            cerr<< " Error when receiving message!"<<endl;
        }
        else {
            // ߳ͬ
            pthread_mutex_lock(&initLock);
            
            // յϢcoach
            (*((InitConnectionT*)arg)->initOK) = true;
            (*((InitConnectionT*)arg)->initMsg) = msgBuf;
            
            pthread_mutex_unlock(&initLock);
            return NULL;
        }
    }    
}


pthread_mutex_t     msgLock = PTHREAD_MUTEX_INITIALIZER;

void *NetRecvMsg(void * arg)
{
    UDPSocket   *s;
    string msgBuf;
    int n;
    
    // socket
    s = ((NetRecvT*) arg)->s;
    
    for(;;){
        // main loop to recv msg
     
        n = s->RecvMsg(msgBuf);
        if (n == -1){
            // there Is sth wrong when recv msg
            cerr<< " Error when receiving message!"<<endl;
        }
        else {
            // ߳ͬ
            pthread_mutex_lock(&msgLock);
            
            // յϢcoach
            ((NetRecvT*)arg)->coach->AddNewMsg(msgBuf);
            if(msgBuf.c_str()[1]=='o' || msgBuf.c_str()[1]=='w'|| msgBuf.c_str()[1]=='e') 
                ((NetRecvT*)arg)->l->Log(0,"%s",msgBuf.c_str());
            // if receive the see_globe message then Update the world model
            if(msgBuf.c_str()[3] == 'e') ((NetRecvT*)arg)->coach->UpdateRoutine();
            ((NetRecvT*)arg)->coach->receiveMsgMark = true;
            
            pthread_mutex_unlock(&msgLock);
        }
        
    }    
  
}




int  main(int argc, char *argv[])
{
        string strTeamName;
        string strServerAddr;
        int iPort;

        if(argc<2)
        {
            cout<<"usage : WECoach TEAMNAME ADDRESS PORT ^_^"<<endl;
            return 0;
        }
        if(argc>=2)
            strTeamName = argv[1];
        else
            strTeamName = "WrightEagle2002";
        if(argc>=3)
            strServerAddr = strcmp(argv[2],"localhost")?argv[2]:"127.0.0.1";
        else
            strServerAddr = "127.0.0.1";
        if(argc>=4)
            iPort = atoi(argv[3]);
        else
            iPort = 6002;
        
        NetRecvT        arg;
        InitConnectionT init_arg;
        bool initOK=false;
        bool isInitOK=false;
        int wait_time=0;
        pthread_t  init_pid;
        WMSnapShot  wms;
        Logger* l = new Logger(LOGFILE_NAME);
        Parse *parse = new Parse(strTeamName);
        UDPSocket  sock;
        pthread_t  recv_pid;
        string strBuf;
        SideT side;
        

        // initialize connection
        // ʧܣ˳
        if ( !sock.InitConnection(strServerAddr,iPort) ) {
            cout<<"connection fail :-("<<endl;
            return -1;
        }

        // initialize coach
        WECoach *coach;
        init_arg.s = &sock;
        init_arg.initOK = &initOK;
        init_arg.initMsg = &strBuf;
        init_arg.teamName = &strTeamName;
		init_arg.online = (iPort==6002?true:false);
        if ( pthread_create(&init_pid, NULL, InitConnection, (void*)&init_arg ) != 0 ){
            cerr<<"Error when creating thread :-("<<endl ;
            exit(-1);
        }
        for ( ; ; ){
            // ߳ͬ
            pthread_mutex_lock(&initLock);
            
            if(initOK) isInitOK = true;
            wait_time++;
            
            pthread_mutex_unlock(&initLock);
            
            if(isInitOK || wait_time>20)
            {
                break;
            }
            else
                usleep(1000);// sleep a while to avoid occupying the cpu too long
        }

        if(!isInitOK)
        {
            cerr<<"Could not connect to server :-P"<<endl;
            pthread_kill(init_pid, SIGQUIT);
            cout<<"Byebye!"<<endl;
            return 0;
        }
        else
            pthread_kill(init_pid, SIGQUIT);

        



        if(strBuf.c_str()[1] == 'i')
        {
            // receive (init l|r ok)
            if(strBuf.c_str()[6] == 'l')
                side = FIELD_SIDE_L;
            else
                side = FIELD_SIDE_R;

            cout<<"----------------------------------------------------"<<endl;
			cout<<"WrightEagle"<<(iPort==6002?" Online ":" ")<<"Coach"<<endl;
            cout<<"Copyright (C) 2002 Multi-agent System Lab,"<<endl;
            cout<<"	University of Science and Technology of China"<<endl;
            cout<<"----------------------------------------------------"<<endl;
            cout<<strBuf<<" ^_^ "<<endl;
            cout<<"Hit CTRL-C to exit"<<endl;
        }
        else
        {
            // receive (error no_such_team_or_already_have_coach)
            cout<<"No such team named "<<strTeamName<<" or already have coach :-P" << endl;
            exit(0);
        }

        FILE *cfp;
        char temp[1024],temp2[1024];
        string ourOwnTeamName;
        double version;
        if( (cfp=fopen(COACH_PARA,"r"))!=NULL)
        {
            while( fgets(temp,1024,cfp)!=NULL)
            {
                if(temp[0]!='#')
                {
                    switch(temp[0])
                    {
                        case 'o':
                            sscanf(temp,"%s%s%s",temp2,temp2,temp2);
                            ourOwnTeamName = temp2;
                            break;
                        case 's':
                            sscanf(temp,"%s%s%s",temp2,temp2,temp2);
                            //cout<<temp2<<endl;
                            if(temp2[0]!='8')
                            {
                                cout<<"The server version is too old :-("<<endl;
                                exit(0);
                            }
                            else if(temp2[3]!='5'||temp2[5]!='6')
                            {
                                cout<<"The server version is not the latest :-P"<<endl;
                                version = 8.5;
                            }
                            else
                                version = 8.6;
                            break;
                        default:
                            break;
                    }
                }
            }
        }

        coach = new WECoach(&sock,parse,strTeamName,l,side);
        
        // receive the parameters from server.
        sock.RecvMsg(strBuf);
		//debug
		//cout<<strBuf<<endl;
        l->Log(0,"%s",strBuf.c_str());
        if(version==8.5)
            coach->ss.SetServerParametersOld(strBuf.c_str());
        else
            coach->ss.SetServerParameters(strBuf.c_str());
        sock.RecvMsg(strBuf);
        l->Log(0,"%s",strBuf.c_str());
        if(version==8.5)
            coach->ps.SetPlayerParameters(strBuf.c_str() );
        else
            coach->ps.SetPlayerParameters(strBuf.c_str());
        for(int iType=0;iType<7;iType++)
        {
            sock.RecvMsg(strBuf);
            l->Log(0,"%s",strBuf.c_str());
            coach->pts.SetPlayerTypeParameters(strBuf.c_str());
        }

        // sort the player types by weight
        coach->pts.SortPlayerType();
        
        // change our teammates' types
        if( !strcmp(ourOwnTeamName.c_str(),strTeamName.c_str() ) )
            coach->ChangeWEPlayerType();
        
        // send define message
        coach->SentDefineMsg();

        // open eyes
        sock.SendMsg("(eye on)");
                
        // open a thread for I/O
        arg.s = &sock;
        arg.coach = coach;
        arg.l = l;
        if ( pthread_create(&recv_pid, NULL, NetRecvMsg, (void*)&arg ) != 0 ){
            cerr<<"Error when creating thread "<<endl ;
            exit(-1);
        }
        
        
        // the main thread execute decision
        // and also do those time-consuMing calculations
        int waitFailCount = 0;
        for ( ; ; ){
            // ߳ͬ
            pthread_mutex_lock(&msgLock);

            //*************
            // decision
            //*************
            coach->Decision((iPort==6002?true:false));

            if(coach->receiveMsgMark)
            {
                waitFailCount = 0;
                coach->receiveMsgMark = false;
            }
            else
                waitFailCount++;
            if(waitFailCount>100) break;

            pthread_mutex_unlock(&msgLock);
            
            // sleep a while to avoid occupying the cpu too long
            usleep(50000);
        }
        
        // kill recv thread and close UDPSocket
        cout<<"Server has been shut down ..."<<endl;
        pthread_kill(recv_pid, SIGQUIT);
        
        // exit 
        delete parse;
        delete coach;
        return 0;

}





