/***************************************************************************
                                  Netif.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _NETIF_H_
#define _NETIF_H_

#include <string>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <iostream>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>

using namespace std;

const int MAXMSG = 8192;

class UDPSocket {
public:
        UDPSocket();
        virtual ~UDPSocket(){};
        
        bool    InitConnection(const string &strSocketAddress, const unsigned  iSocketPort);
        bool    InitConnection(const char* strSocketAddress, const unsigned iSocketPort);
        
        int     SendMsg(const string &strMsg);
        int     SendMsg(const char* strMsg);

        int     RecvMsg(string &strMsg);
        int     RecvMsg(char *strMsg);
 
 private:
        int                 sockfd;
        sockaddr_in         address;  
};

#endif
