/***************************************************************************
                               ServerSetting.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _SERVERSetTING_H_
#define _SERVERSetTING_H_

//#include <ostream>
#include <cstdio>
#include <string>
#include <strstream>
#include <iostream>
#include "Types.h"
#include "Logger.h"

using namespace std;

class ServerSetting{
public:
        ServerSetting(void);
        
        void    SetLogger(Logger *log);
        
        Logger  *l;

        int     catch_ban_cycle;//5)
        int     clang_advice_win;//1)
        int     clang_define_win;//1)
        int     clang_info_win;//1)
        int     clang_mess_delay;//50)
        int     clang_mess_per_cycle;//1)
        int     clang_meta_win;//1)
        int     clang_win_size;//300)
        int     coach_port;//6001)
        int     drop_ball_time;//200)
        int     freeform_send_period;//20)
        int     freeform_wait_period;//600)
        int     game_log_compression;//0)
        int     game_log_version;//3)
        int     goalie_max_moves;//2)
        int     half_time;//3000)
        int     hear_decay;//1)
        int     hear_inc;//1)
        int     hear_max;//1)
        int     max_goal_kicks;//3)
        int     olcoach_port;//6002)
        int     point_to_ban;//5)
        int     point_to_duration;//20)
        int     port;//6000)
        int     recv_step;//10)
        int     say_coach_cnt_max;//128)
        int     say_coach_msg_size;//128)
        int     say_msg_size;//10)
        int     send_step;//150)
        int     send_vi_step;//100)
        int     sense_body_step;//100)
        int     simulator_step;//100)
        int     slow_down_factor;//1)
        int     start_goal_l;//0)
        int     start_goal_r;//0)
        int     synch_micro_sleep;//1)
        int     synch_offset;//60)
        int     tackle_cycles;//10)
        int     text_log_compression;//0)
        string  game_log_dir;//"./")
        string  game_log_fixed_name;//"rcssserver")
        string  landmark_file;//"~/.rcssserver-landmark.xml")
        string  log_date_format;//"%Y%m%d%H%M-")
        string  replay;//"")
        string  text_log_dir;//"./")
        string  text_log_fixed_name;//"rcssserver")
        int     coach;//0)
        int     coach_w_referee;//0)
        int     old_coach_hear;//0)
        int     wind_none;//0)
        int     wind_random;//0)
        int     back_passes;//1)
        int     forbid_kick_off_offside;//1)
        int     free_kick_faults;//1)
        int     fullstate_l;//0)
        int     fullstate_r;//0)
        int     game_log_dated;//1)
        int     game_log_fixed;//0)
        int     game_logging;//1)
        int     log_times;//1)
        int     profile;//0)
        int     proper_goal_kicks;//1)
        int     record_messages;//1)
        int     send_comms;//1)
        int     synch_mode;//0)
        int     team_actuator_noise;//0)
        int     text_log_dated;//1)
        int     text_log_fixed;//0)
        int     text_logging;//1)
        int     use_offside;//1)
        int     verbose;//0)
        int     audio_cut_dist;//50)
        double  ball_accel_max;//2.7)
        double  ball_decay;//0.94)
        double  ball_rand;//0.05)
        double  ball_size;//0.085)
        double  ball_speed_max;//2.7)
        double  ball_weight;//0.2)
        double  catch_probability;//1)
        double  catchable_area_l;//2)
        double  catchable_area_w;//1)
        double  ckick_margin;//1)
        double  control_radius;//2)
        double  dash_power_rate;//0.006)
        double  effort_dec;//0.005)
        double  effort_dec_thr;//0.3)
        double  effort_inc;//0.01)
        double  effort_inc_thr;//0.6)
        double  effort_init;//0)
        double  effort_min;//0.6)
        double  goal_width;//14.02)
        double  inertia_moment;//5)
        double  kick_power_rate;//0.027)
        double  kick_rand;//0)
        double  kick_rand_factor_l;//1)
        double  kick_rand_factor_r;//1)
        double  kickable_margin;//0.7)
        double  maxmoment;//180)
        double  maxneckang;//90
        double  maxneckmoment;//180)
        double  maxpower;//100)
        double  minmoment;//-180)
        double  minneckang;//-90)
        double  minneckmoment;//-180)
        double  minpower;//-100)
        double  offside_active_area_size;//5)
        double  offside_kick_margin;//9.15)
        double  player_accel_max;//1)
        double  player_decay;//0.4)
        double  player_rand;//0.1)
        double  player_size;//0.3)
        double  player_speed_max;//1)
        double  player_weight;//60)
        double  prand_factor_l;//1)
        double  prand_factor_r;//1)
        double  quantize_step;//0.1)
        double  quantize_step_l;//0.01)
        double  recover_dec;//0.002)
        double  recover_dec_thr;//0.3)
        double  recover_min;//0.5)
        double  slowness_on_top_for_left_team;//1)
        double  slowness_on_top_for_right_team;//1)
        double  stamina_inc_max;//45)
        double  stamina_max;//4000)
        double  stopped_ball_vel;//0.01)
        double  tackle_back_dist;//0.5)
        double  tackle_dist;//2.5)
        double  tackle_exponent;//6)
        double  tackle_power_rate;//0.027)
        double  tackle_width;//1.25)
        double  visible_angle;//90)
        double  visible_distance;//3)
        double  wind_ang;//0)
        double  wind_dir;//0)
        double  wind_force;//0)
        double  wind_rand;//0)
        
        int     SetServerParameters(const char* s);
        int     OutServerParameters();
        
        int     SetServerParametersOld(const char* s);
        double  player_speed_Max;
        double  player_accel_Max;
        int     subs_Max;
        int     pt_Max;
        int     lcm_step;
        int     say_coach_cnt_Max;
        int     staMina_Max;
        double     staMina_inc_Max;
        double     recover_init;
        double      recover_Min;
        double      effort_Min;
        double      ball_speed_Max;
        double      ball_accel_Max;
        double      control_radius_width;
        int     goalie_Max_moves;
        double  Maxpower;
        double  Minpower;
        double  Maxmoment;
        double  Minmoment;
        double  Maxneckmoment;
        double  Minneckmoment;
        double  Maxneckang;
        double  Minneckang;
        double  quantize_step_dir;
        double  quantize_step_dist_team_l;
        double  quantize_step_dist_team_r;
        double  quantize_step_dist_l_team_l;
        double  quantize_step_dist_l_team_r;
        double  quantize_step_dir_team_l;
        double  quantize_step_dir_team_r;
        double  kickable_area;
        double  hear_Max;
        double  synch_offSet;
};


class PlayerSetting{
public:
        PlayerSetting(void);

        void    SetLogger(Logger *log);
        
        Logger  *l;

        int     player_types;//7)
        int     pt_max;//3)
        double  random_seed;//-1)
        double  subs_max;//3)
        double  dash_power_rate_delta_max;//0.002)
        double  dash_power_rate_delta_min;//0)
        double  effort_max_delta_factor;//-0.002)
        double  effort_min_delta_factor;//-0.002)
        double  extra_stamina_delta_max;//100)
        double  extra_stamina_delta_min;//0)
        double  inertia_moment_delta_factor;//25)
        double  kick_rand_delta_factor;//0.5)
        double  kickable_margin_delta_max;//0.2)
        double  kickable_margin_delta_min;//0)
        double  new_dash_power_rate_delta_max;//0.002)
        double  new_dash_power_rate_delta_min;//0)
        double  new_stamina_inc_max_delta_factor;//-10000)
        double  player_decay_delta_max;//0.2)
        double  player_decay_delta_min;//0)
        double  player_size_delta_factor;//-100)
        double  player_speed_max_delta_max;//0.2)
        double  player_speed_max_delta_min;//0)
        double  stamina_inc_max_delta_factor;//-100)
        
        int     SetPlayerParameters(const char* p);
        int     OutPlayerParameters();
        
        int     SetPlayerParametersOld(const char *p);
        double  inteffort_Min_delta_factor;
        double  effort_Max_delta_factor;
        double  extra_staMina_delta_Max;
        double  extra_staMina_delta_Min;
        double  kickable_margin_delta_Max;
        double  kickable_margin_delta_Min;
        double  dash_power_rate_delta_Max;
        double  dash_power_rate_delta_Min;
        double  player_decay_delta_Max;
        double  player_decay_delta_Min;
        double  staMina_inc_Max_delta_factor;
        double  player_speed_Max_delta_Max;
        double  player_speed_Max_delta_Min;
        double  pt_Max;
        double  subs_Max;
};


class HetroPlayerType{
public:
        int     id;
        double  player_speed_Max;
        double  staMina_inc_Max;
        double  player_decay;
        double  inertia_moment;
        double  dash_power_rate;
        double  player_size;
        double  kickable_margin;
        double  kick_rand;
        double  extra_staMina;
        double  effort_Max;
        double  effort_Min;
        
        int     SetHetroPlayerType(const char* hpt);
        int     OutHetroPlayerType();
};


class PlayerTypeSetting{
public:
        PlayerTypeSetting(void);

        void    SetLogger(Logger *l);
        
        Logger  *l;

        HetroPlayerType type[MAX_TYPE_NUMBER];
        
        int     SetPlayerTypeParameters(const char* pt);
        int     OutPlayerTypeParameters();

        int     SortPlayerType();
        double PlayerTypeSetting::CalculateWeight(
                double speedWeight,
                double persistenceWeight,
                double recoveryWeight,
                double kickareaWeight,
                double exactnessWeight
                );
        
        int     SelectForwardCenter();
        int     SelectForwardSide();
        int     SelectBackCenter();
        int     SelectBackSide();
        int     SelectMiddle();

        double typeTable[TYPE_NUMBER][MAX_TYPE_NUMBER];    // role | type -- utility 
                                                    //PT_NONE,            //0
                                                    //PT_FORWARD_CENTER,  //1
                                                    //PT_MIDFIELD,        //2
                                                    //PT_BACK_CENTER,     //3
                                                    //PT_FORWARD_SIDE,    //4
                                                    //PT_BACK_SIDE,       //5
        int     typeOnField[MAX_TYPE_NUMBER];
        
        float roleBaseWeight[TYPE_NUMBER][5];
                                                    //PT_NONE,            //0
                                                    //PT_FORWARD_CENTER,  //1
                                                    //PT_MIDFIELD,        //2
                                                    //PT_BACK_CENTER,     //3
                                                    //PT_FORWARD_SIDE,    //4
                                                    //PT_BACK_SIDE,       //5
};


#endif




