/***************************************************************************
                                  Types.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _TYPES_H_
#define _TYPES_H_

using namespace std;

#include <string>
#include <list>
#include <vector>


#define MIN_INTERVAL 300
#define UPDATE_FORMATION_INTERVAL 300
#define UPDATE_FORMATION_PERIOD 100
#define MIN_UPDATE_FORMATION_INTERVAL 10
#define FORWARD_X_DIFF_THRESHOLD 0.2
#define BACK_X_DIFF_THRESHOLD 0.2
#define CENTER_Y_THRESHOLD 0.3
#define TEAM_SIZE 12
#define FORM_PARA "./par/formation.par"
#define DEFINE_PARA "./par/define.par"
#define ROLEWEIGHT_PARA "./par/roleweight.par"
#define COACH_PARA "./par/coach.par"
#define CLIENT_CONF "./conf/client.conf"
#define FORMATION_CONF "./conf/formations.conf"
#define CHANGE_FORMATION_THRESHOLD 100

#define     MAX_TYPE_NUMBER 7
#define     TYPE_NUMBER 6
#define     TYPE_ON_FIELD_NUMBER 3

#define     REGION_LEFT_BUF -1
#define     REGION_RIGHT_BUF 1
#define     REGION_TOP_BUF -1
#define     REGION_BOTTOM_BUF 1


const int MAX_PLAYER_NUMBER = 11;            // Max num of players in one team

#define     POSITION_MODEL_PREFIX_NUMBER 5
#define     MAX_NUMBER 1000000

#define     FORWARD_FIELD_THRESHOLD 18
#define     BACK_FIELD_THRESHOLD -18

#define     SHOOT_BALL_SPEED_THRESHOLD 1.7
#define     SHOOT_DISTANCE_TO_GOAL_THRESHOLD 23
#define     SHOOT_GOAL_HALF_WIDTH_THRESHOLD 8.0

#define     PASS_CYCLE_MAX_THRESHOLD 30
#define     PLAYER_AVARIAGE_VELOCITY 0.8
#define     DRIBBLE_BALL_SPEED_THRESHOLD 1.0

#define     NICE_TEAMPLAY_THRESHOLD 0.0
#define     ACCEPTABLE_TEAMPLAY_THRESHOLD 0.0

#define     ADVICE_LIVE_TIME_NORMAL 300
#define     MAX_TOKEN_LENGTH 2000

#define     FIELD_LENGTH 105
#define     FIELD_WIDTH 68

#define     LOGFILE_NAME "./Logfiles/coach.log"

#define     OUR_OWN_TEAM_NAME "WrightEagle2002"

#define     NICE_CONTROL_RATIO_DIFF 0.6
#define     GOOD_CONTROL_RATIO_DIFF 0.5
#define     ACCEPTABLE_CONTROL_RATIO_DIFF 0.45
#define     BAD_CONTROL_RATIO_DIFF 0.4
#define     TERRIBLE_CONTROL_RATIO_DIFF 0.35

#define     NEAR_THRESHOLD 8
#define     ACT_NEAR_THRESHOLD 20

#define     CONTROL_DIFF_THRESHOLD 0.4

//      The PlayModeT enumeration contains all playmodes of the soccer playmode.
//  The associated string values can be returned using the methods in the  SoccerTypes class
enum PlayModeT {
  PM_BEFORE_KICK_OFF,  // before_kick_off: before kick off  
  PM_KICK_OFF_LEFT,    // kick_off_l:      kick off for left team   
  PM_KICK_OFF_RIGHT,   // kick_off_r:      kick off for right team  
  PM_KICK_IN_LEFT,     // kick_in_l:       kick in for left team   
  PM_KICK_IN_RIGHT,    // kick_in_r:       kick in for right team   
  PM_CORNER_KICK_LEFT, // corner_kick_l:   corner kick left team   
  PM_CORNER_KICK_RIGHT,// corner_kick_r:   corner kick right team  
  PM_GOAL_KICK_LEFT,   // goal_kick_l:     goal kick for left team 
  PM_GOAL_KICK_RIGHT,  // goal_kick_r:     goal kick for right team 
  PM_GOAL_LEFT,        // goal_l:          goal scored by team left 
  PM_GOAL_RIGHT,       // goal_r:          goal scored by team right
  PM_FREE_KICK_LEFT,   // free_kick_l:     free kick for left team
  PM_FREE_KICK_RIGHT,  // free_kick_r:     free kick for right team 
  PM_OFFSIDE_LEFT,     // offside_l:       offside for left team    
  PM_OFFSIDE_RIGHT,    // offside_r:       offside for right team  
  PM_PLAY_ON,          // play_on:         play on (during match)  
  PM_TIME_OVER,        // time_over:       time over (after match) 
  PM_FROZEN,           // game play Is frozen   
  PM_DROP_BALL,
  PM_QUIT,             //  quit                
  PM_ILLEGAL           //  unknown playmode  
} ;

enum SideT{
        FIELD_SIDE_L,
        FIELD_SIDE_R
};


// ¼
enum EventN{
    EV_GOAL_LEFT,       // goal scored by team left
    EV_GOAL_RIGHT,      // goal scored by team right
    EV_GOAL_KICK_LEFT,  // goal kick for left team 
    EV_GOAL_KICK_RIGHT, // goal kick for right team 
    EV_OFFSIDE_LEFT,    // offside for left team
    EV_OFFSIDE_RIGHT,   // offside for right team
    EV_FREE_KICK_LEFT,  // free kick for left team
    EV_FREE_KICK_RIGHT, // free kick for right team
    EV_KICK_OFF_LEFT,   // kick off for left team   
    EV_KICK_OFF_RIGHT,  // kick off for right team  
    EV_KICK_IN_LEFT,    // kick in for left team   
    EV_KICK_IN_RIGHT,   // kick in for right team
    EV_CORNER_KICK_LEFT, //corner kick left team   
    EV_CORNER_KICK_RIGHT,//corner kick right team  
    EV_DROP_BALL,
    
    // other events
    EV_GET_SERVER_PARAM, //get the server parameter
    EV_GET_PLAYER_PARAM, //get the player parameter
    EV_GET_PLAYER_TYPE,  //get the player type information
    EV_SEE_OUR_GOALIE,  // ҷԱ
    EV_SEE_OPP_GOALIE,  // ԷԱ
    EV_SEE_OUR_NAME,    // ҷĶ
    EV_SEE_OPP_NAME,      // Ķ
    EV_SEE_OUR_SIDE,      // ҷǱ
    EV_SEE_OPP_SIDE,      // ԷǱ
    EV_SEE_OUR_GOAL,      // ҷ÷
    EV_SEE_OPP_GOAL,    // Է÷

    EV_MISS_SEE_MSG     // ʧSEE MSG

};

struct EventT{
        EventN            name;   // event name
        string            value;      // ַ洢ֵ
};


//Ϣ
enum MsgState{
        MsgS_Msg_Come,  // msg come
        MsgS_See_Msg_Come, // see msg come
        MsgS_Hear_Msg_Come, // hear msg come
        MsgS_No_Msg_Come    // no msg come
};


// player type definition
enum PlayerRoleT{
        PT_NONE,            //0
        PT_FORWARD_CENTER,  //1
        PT_MIDFIELD,        //2
        PT_BACK_CENTER,     //3
        PT_FORWARD_SIDE,    //4
        PT_BACK_SIDE,       //5
        PT_FORWARD_LEFT,
        PT_FORWARD,
        PT_FORWARD_RIGHT,
        PT_MIDFIELD_LEFT,
        PT_MIDFIELD_CENTER,
        PT_MIDFIELD_RIGHT,
        PT_BACK_LEFT,
        PT_BACK,
        PT_BACK_RIGHT,
        PT_GOALIE
};


// types of commands from coach to server
enum CommandT{
        CT_TOKEN,
        CT_COMMAND,
        CT_DEFINE,
        CT_SAY
};

// struct of the element of sendMsgQ
struct Command{
        CommandT type;
        string c;
        int     createTime;
        bool    status;
};


// player middle level action type
enum ActionT{
        AT_NONE,
        AT_DRIBBLE,
        AT_PASS,
        AT_SHOOT,
        AT_HOLD,
        AT_POSITION,
        AT_INTERCEPT,
        AT_APPROACH,
        AT_TACKLE,
        AT_CATCH
};


// player behavior structure
struct Behavior{
        ActionT     action;
        SideT       side;
        int         ativePlayer;
        list<int>   passivePlayer;
};


// the variary describe the control situation on the field,
// that Is which side Is possessing ball.
enum BallPossessionT{
        BP_NONE,
        BP_OPP,
        BP_OUR,
        BP_OUR_TO_NONE,
        BP_OPP_TO_NONE,
        BP_OUR_TO_OPP,
        BP_OPP_TO_OUR
};
        

enum TeamT{
        TT_NONE,
        TT_OUR,
        TT_OPP
};



struct Region{
        double      top;
        double      bottom;
        double      left;
        double      right;
};


enum PlayerActT{
        PAT_NONE,
        PAT_HOME,
        PAT_POS,
        PAT_PASS,
        PAT_DRIBBLE,
        PAT_CLEAR,
        PAT_SHOOT,
        PAT_HOLD,
        PAT_INTERCEPT,
        PAT_TACKLE,
        PAT_MARK,
        PAT_MARKL,
        PAT_APPROACH
};


struct PlayerActS{
        PlayerActT  actType;
        Region      actRegion;
        int         actMate;
};

struct TeamActS{
        int         time;
        PlayModeT   playMode;
        Region      ballPos;
        Region      matePos[MAX_PLAYER_NUMBER];
        Region      oppPos[MAX_PLAYER_NUMBER];
        PlayerActS  mateAct[MAX_PLAYER_NUMBER];
        int         organizer;
        double      utility;
        bool        set;
};


struct BallPossessionStruct{
        bool        set;
        int         startTime;
        int         endTime;
        int         possessionTime;
        vector<TeamActS>    actionQueue;
};


enum FormationT{
        FT_NONE,
        FT_424,
        FT_433,
        FT_442,
        FT_451,
        FT_352,
        FT_343,
        FT_334,
        FT_532,
        FT_0
};


enum Tactic{
	TA_FSTC, // µ״
	TA_CTS, // ·ֱ
	TA_STC, // б·
	TA_COF, // Խλ
	TA_BCLOSS, // бת
	TA_Left,
	TA_Right,
	TA_Middle,
	TA_Corner
};


enum ActionMode{
        AM_DO,
        AM_DONT
};


struct RuleRecord{
    string  ruleName;
    int     onTime;
    bool    sent;
    bool    on;
};


#endif



                       

